function checkVariable()

	-- initialize if not done
	if ( not hokutoNoMonkConfig ) then 
	 	hokutoNoMonkConfig = {}; 
	end
	if ( not hokutoNoMonkConfig.volume) then 
	 	hokutoNoMonkConfig.volume = ""; 
	end
	if ( not hokutoNoMonkConfig.channel ) then 
	 	hokutoNoMonkConfig.channel = "SFX"; 
	end
	if ( not hokutoNoMonkConfig.moves ) then 
	 	hokutoNoMonkConfig.moves = {}; 
	end
	if ( not hokutoNoMonkConfig.moves.par ) then 
	--Paralysis par
		hokutoNoMonkConfig.moves.par = "on"; 
	end
	if ( not hokutoNoMonkConfig.moves.tod ) then 
	--"Touch of Death" 
		hokutoNoMonkConfig.moves.tod = "on"; 
	end
	if ( not hokutoNoMonkConfig.moves.fb ) then 
	--"Fortifying Brew"
		hokutoNoMonkConfig.moves.fb = "on"; 
	end
	if ( not hokutoNoMonkConfig.moves.tb ) then 
	--"Tigereye Brew"
		hokutoNoMonkConfig.moves.tb = "on"; 
	end
	if ( not hokutoNoMonkConfig.moves.fof ) then 
	--"Fists of Fury"
		hokutoNoMonkConfig.moves.fof = "on"; 
	end
	if ( not hokutoNoMonkConfig.moves.rsk ) then 
		hokutoNoMonkConfig.moves.rsk = "on"; 
	end
	if ( not hokutoNoMonkConfig.moves.tp ) then 
		hokutoNoMonkConfig.moves.tp = "on"; 
	end
	if ( not hokutoNoMonkConfig.moves.bok ) then 
		hokutoNoMonkConfig.moves.bok = "on"; 
	end
	if ( not hokutoNoMonkConfig.moves.bok ) then 
		hokutoNoMonkConfig.moves.bok = "on"; 
	end
	if ( not hokutoNoMonkConfig.moves.sck ) then 
		hokutoNoMonkConfig.moves.sck = "on"; 
	end

	
 end

print ("Welcome to HokutoNoMonk type /hnm or /nomonk to learn command line settings and options")

local function reset() 
	print ("reset ")
	hokutoNoMonkConfig.volume = ""; 
	hokutoNoMonkConfig.channel = "SFX"; 
	hokutoNoMonkConfig.moves.par = "on"; 
 	hokutoNoMonkConfig.moves.tod = "on"; 
 	hokutoNoMonkConfig.moves.fb = "on"; 
 	hokutoNoMonkConfig.moves.tb = "on"; 
	hokutoNoMonkConfig.moves.fof = "on"; 
	hokutoNoMonkConfig.moves.tp = "on"; 
	hokutoNoMonkConfig.moves.rsk = "on"; 
	hokutoNoMonkConfig.moves.bok = "on";
	hokutoNoMonkConfig.moves.sck = "on";  
end



local function setMoveFlag(move,status) 
	if (move=="par") then 
		hokutoNoMonkConfig.moves.par = status
	end
	if (move=="tod") then 
		hokutoNoMonkConfig.moves.tod = status
	end
	if (move=="fb") then 
		hokutoNoMonkConfig.moves.fb = status
	end
	if (move=="tb") then 
		hokutoNoMonkConfig.moves.tb = status
	end
	if (move=="fof") then 
		hokutoNoMonkConfig.moves.fof = status
	end
	if (move=="tp") then 
		hokutoNoMonkConfig.moves.tp = status
	end
	if (move=="rsk") then 
		hokutoNoMonkConfig.moves.rsk = status
	end
	if (move=="bok") then 
		hokutoNoMonkConfig.moves.bok = status
	end
	if (move=="sck") then 
		hokutoNoMonkConfig.moves.sck = status
	end
end

local function allon (move)
print ("set on", move)
if ( not move) then
	hokutoNoMonkConfig.moves.par = "on"; 
 	hokutoNoMonkConfig.moves.tod = "on"; 
 	hokutoNoMonkConfig.moves.fb = "on"; 
 	hokutoNoMonkConfig.moves.tb = "on"; 
	hokutoNoMonkConfig.moves.fof = "on"; 
	hokutoNoMonkConfig.moves.tp = "on"; 
	hokutoNoMonkConfig.moves.rsk = "on"; 
	hokutoNoMonkConfig.moves.bok = "on"; 
	hokutoNoMonkConfig.moves.sck = "on";
 else
 	print ("resetting only ", move)
 	setMoveFlag(move,"on")
 end
end

local function alloff(move)
print ("set off", move)
if ( not move) then
 hokutoNoMonkConfig.moves.par = "off"; 
 hokutoNoMonkConfig.moves.tod = "off"; 
 hokutoNoMonkConfig.moves.fb = "off"; 
 hokutoNoMonkConfig.moves.tb = "off"; 
 hokutoNoMonkConfig.moves.fof = "off"; 
 hokutoNoMonkConfig.moves.tp = "off"; 
hokutoNoMonkConfig.moves.rsk = "off"; 
hokutoNoMonkConfig.moves.bok = "off"; 
hokutoNoMonkConfig.moves.sck = "off";
 else
 	print ("resetting only ", move)
 	setMoveFlag(move,"off")
 end
end

local hnmCommandTable = {

	["effect"]={
		["alt"] = function ()
			print ("set to alternative sound")
			hokutoNoMonkConfig.volume = "alt"; 
		end,
		["normal"]= function()
			print("set to low volume")
			hokutoNoMonkConfig.volume = ""; 
		end,
		["help"]= "Type either normal or alt effects. only final and rising sun kick have alternative."
	},
	["channel"]={
		["music"] = function ()
			print ("set to music")
			hokutoNoMonkConfig.channel = "Music"
		end,
		["sfx"]= function()
			print("set to SFX")
			hokutoNoMonkConfig.channel = "SFX"
		end,
		["ambience"]= function()
			print("set to ambience")
			hokutoNoMonkConfig.channel = "Ambience"
		end,
		["master"]= function()
			print("set to ambience")
			hokutoNoMonkConfig.channel = "Master"
		end,
		["help"]= "Type either ambience, music, master or sfx. i.e. channel SFX. Master low other sound effects while playing the Hokutonomonk effects, while SFX does not alterates other sounds"
	},
	["move"]={
		["on"] = function (move)
			allon(move)
		end,
		["off"]= function(move)
			alloff(move)
		end,
		["help"]= "Type either off to disable or on. if you type move and a name of move you will enable or disable only that move. i.e. move off, move off fof. Available moves are: tigereye brew (tb), spinning crane kick (sck), blackout kick (bok),fortifing brew (fb), touch of death (tod), paralysis (par), fist of fury (fof),  rising sun kick (rsk), tiger palm (tp), "
	},
	["reset"] = function () 
		reset()
	end,
	["help"] = "Welcome to Hokutonomonk command line. you can control: effect, channel or move. If you type a command followed by help you get help for the specific setting details. i.e. /honomonk effect help"
	
}


local frame =  CreateFrame("FRAME", "okutonomonk");
frame:RegisterEvent("VARIABLES_LOADED"); 
frame:RegisterEvent("ADDON_LOADED");



local function DispatchCommand(message,commandTable)
	local command,parameters = string.split(" ",message,2)
	local entry = commandTable[command:lower()]
	local which = type(entry)
	if which == "function" then
		entry(parameters)
	elseif which == "table" then
		DispatchCommand(parameters or "", entry)
	elseif which == "string" then
		print(entry)
	elseif message ~= "help" then
		DispatchCommand("help", commandTable)	
	end
end
SLASH_NOMONK1,SLASH_NOMONK2 = "/nomonk","/hnm";
SlashCmdList["NOMONK"] = function (message)
		DispatchCommand(message,hnmCommandTable);
end




 -- init variable and frame
local function hokutoNoMonk_Init()
	frame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP");
	frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	frame:RegisterEvent("SPELL_CAST_SUCCESS");
	
end 




local playingvar = "no";

local function settingTable()
	
end

local function eventHandler(self, event, ...)

	if event=="VARIABLES_LOADED" then
		checkVariable()
		hokutoNoMonk_Init();
		
	end
	
	if event== "UNIT_SPELLCAST_CHANNEL_STOP" then 
			playingvar="no"
		end
	if event== "CURRENT_SPELL_CAST_CHANGED" then 
			playingvar="no"
		end
	if event=="COMBAT_LOG_EVENT_UNFILTERED" then
		local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...)
		local player = UnitGUID("player")

		if type=="SPELL_CAST_SUCCESS" then
			
			local spellId, spellName, spellSchool = select(12, ...)
			local spellLink = GetSpellLink(spellId)
			if spellName=="Touch of Death" and sourceGUID==player and hokutoNoMonkConfig.moves.tod == "on"then	
					local file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\finisherhigh.ogg"
					if (hokutoNoMonkConfig.volume == "alt") then
						 file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\finalfatality.ogg"
					end
					PlaySoundFile(file , hokutoNoMonkConfig.channel)
			end
			if spellName=="Blackout Kick" and sourceGUID==player and hokutoNoMonkConfig.moves.bok == "on"then	
					local file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\rising.ogg"
					PlaySoundFile(file , hokutoNoMonkConfig.channel)
			end
			if spellName=="Paralysis" and sourceGUID==player and hokutoNoMonkConfig.moves.par == "on" then
					local file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\attahigh.ogg"		
					PlaySoundFile(file, hokutoNoMonkConfig.channel)
				
			end
			if spellName=="Fortifying Brew" and sourceGUID==player and hokutoNoMonkConfig.moves.fb == "on" then
				local file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\rageloadhigh.ogg"		
				PlaySoundFile(file, hokutoNoMonkConfig.channel)
			end
			if spellName=="Tigereye Brew" and sourceGUID==player and hokutoNoMonkConfig.moves.tb == "on" then
					local file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\rageloadhigh.ogg"
					PlaySoundFile(file, hokutoNoMonkConfig.channel)
			end
			if spellName=="Tiger Palm" and sourceGUID==player and hokutoNoMonkConfig.moves.tp == "on" then
					local file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\punch.ogg"
					PlaySoundFile(file, hokutoNoMonkConfig.channel)
			end
			if spellName=="Rising Sun Kick" and sourceGUID==player and hokutoNoMonkConfig.moves.rsk == "on" then
					local file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\rata.ogg"
					if (hokutoNoMonkConfig.volume == "alt") then
						 file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\kickuatta.ogg"
					end
					PlaySoundFile(file, hokutoNoMonkConfig.channel)
			end
			if spellName=="Spinning Crane Kick" and sourceGUID==player and hokutoNoMonkConfig.moves.sck == "on" then
					local file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\kick.ogg"
					PlaySoundFile(file, hokutoNoMonkConfig.channel)
			end
			if spellName=="Fists of Fury" and sourceGUID==player and hokutoNoMonkConfig.moves.fof == "on" then
				if (playingvar=="no") then
					
					local  file = "Interface\\AddOns\\HokutoNoMonk\\sounds\\tatatatahigh.ogg"
				
					PlaySoundFile(file, hokutoNoMonkConfig.channel)
				end
				if (playingvar=="no") then
					playingvar="yes"
				end
			end
			
		end
	end
	
end

function hokutoNoMonk_setdefaults()
	--hokutoNoMonkConfig
end

frame:SetScript("OnEvent", eventHandler);
--frame:SetScript("OnEvent", frame.OnEvent);